package de.donmanfred;

import me.alexrs.circularbutton.lib.CircularButton;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;

@Version(1.00f)
@ShortName("Circularbutton")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
//@Events(values={"onSigned(sign As Object)"})
//@DependsOn(values={"android-viewbadger"})
public class CircularButtonWrapper extends ViewWrapper<CircularButton> implements DesignerCustomView {
	private BA ba;
	private String eventName;
  private CircularButton cb;
	
	
	/*
	 * Initialize the HTML-TextView 
	 */   	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cb = new CircularButton(ba.context);
		//this.setObject(new CircularButton(ba.context));
 	}

	public void setImageBitmap(Bitmap bm)	{
		cb.setImageBitmap(bm);
		cb.invalidate();
	}

	public void setButtonColor(int color)	{
		cb.setButtonColor(color);
	}
	
	public void setShadowColor(int color)	{
		cb.setShadowColor(color);
	}

	
	//programmatically add view
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		//AttributeSet attrs;		
		//XmlPullParser parser = Resources.getXml(myResouce);
		//AttributeSet myAttributes = Xml.asAttributeSet(parser);
		//AttributeSet myAttributes = null;
		//anywheresoftware.b4a.		 
		//mSignaturePad = new SignaturePad(ba.context, myAttributes);
		Parent.addView(cb, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cb.getLayoutParams();
		lp.left = left;
		cb.getParent().requestLayout();
	}
	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cb.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cb.getLayoutParams();
		lp.top = top;
		cb.getParent().requestLayout();
	}
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cb.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cb.getLayoutParams();
		lp.width = Width;
		cb.getParent().requestLayout();
	}
	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cb.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cb.getLayoutParams();
		lp.height = height;
		cb.getParent().requestLayout();
	}
	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cb.getLayoutParams();
		return lp.height;
	}
	
}
